template < typename T >
curlpp::registry_base< T >::~registry_base()
{}

template < typename T >
std::list< T >
curlpp::registry_base< T >::handles()
{
   return m_handles;
}

template < typename T >
void
curlpp::registry_base< T >::record
   ( const T &handle )
{
   registry_manager::instance().record( handle, this );
}

template < typename T >
void
curlpp::registry_base< T >::unrecord
   ( const T &handle )
{
   registry_manager::instance().unrecord( handle, this );
}

template < typename T >
void
curlpp::registry_base< T >::refresh_all()
{
   for (
      typename std::list< T >::iterator pos = m_handles.begin();
      pos != m_handles.end();
      pos++
   )
   {
      refresh( ( *pos ) );
   }
}

template < typename T >
void
curlpp::registry_base< T >::refresh( const T & )
{}

template < typename T >
void
curlpp::registry_base< T >::insert( const T &handle )
{
   typename std::list< T >::iterator pos;
   
   pos = m_handles.begin();
   while ( ( pos != m_handles.end() ) || ( ( *pos ) == handle ) )
   {
      pos++;
   }
   
   if ( pos == m_handles.end() )
   {
      m_handles.push_back( handle );
      refresh( handle );
   }
}

template < typename T >
void
curlpp::registry_base< T >::remove( const T &handle )
{
   typename std::list< T >::iterator pos;
   
   pos = m_handles.begin();
   while ( ( pos != m_handles.end() ) && ( ( *pos ) != handle ) )
   {
      pos++;
   }
   
   if ( pos != m_handles.end() )
   {
      m_handles.erase( pos );
   }
}




