/*
*    Copyright (c) <2002-2003> <Jean-Philippe Barrette-LaPierre>
*    
*    Permission is hereby granted, free of charge, to any person obtaining
*    a copy of this software and associated documentation files 
*    (curlpp), to deal in the Software without restriction, 
*    including without limitation the rights to use, copy, modify, merge,
*    publish, distribute, sublicense, and/or sell copies of the Software,
*    and to permit persons to whom the Software is furnished to do so, 
*    subject to the following conditions:
*    
*    The above copyright notice and this permission notice shall be included
*    in all copies or substantial portions of the Software.
*    
*    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
*    OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
*    MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
*    IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY 
*    CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, 
*    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
*    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/

#ifndef REGISTRY_MANAGER_BASE_HH
#define REGISTRY_MANAGER_BASE_HH

#include <list>

namespace curlpp
{
   template < typename T >
   class registry_base;
   
   /**
    * This class is used for a virtual base class for registry_manager_singleton 
    * and registry_manager.
    */
   template < typename T >
   class registry_manager_base
   {
      public:
         virtual void record
            (
               T *handle,
               registry_base< T > *registry
            ) = 0;
            
         virtual std::list< registry_base< T > * >
         registries( T *handle ) = 0;
         
         virtual void unrecord
            (
               T *handle,
               registry_base< T > *registry
            ) = 0;

         virtual void unrecord
            (
               T *handle
            ) = 0;
   };
};

#endif //REGISTRY_MANAGER_BASE_HH

