#include <iostream>


template < typename T >
void
curlpp::registry_manager_impl< T >::record
   (
      const T &handle,
      registry_base< T > *registry_handle
   )
{
   typename std::multimap< T, registry_base< T > * >::iterator pos;
   
   pos = m_registry.find( handle );
   while ( pos != m_registry.end() )
   {
      if ( ( *pos ).second == registry_handle )
      {
         m_registry.erase( pos );
         pos = m_registry.end();
      }
      else
      {
         pos++;
      }
   }
   
   m_registry.insert( std::make_pair( handle, registry_handle ) );
   registry_handle->insert( handle );
}

template < typename T >
std::list< curlpp::registry_base< T > * >
curlpp::registry_manager_impl< T >::registries( const T &handle )
{
   std::list< curlpp::registry_base< T > * > handle_list;
   
   for (
      typename std::multimap< T, registry_base< T > * >::iterator
      pos = m_registry.find( handle );
      pos != m_registry.end();
      pos++
   )
   {
      handle_list.push_back( ( *pos ).second );
   }
   
   return handle_list;
}

//\TODO see the TODO for curlpp::registry_manager_impl< T >::unrecord(
//const const T & );

template < typename T >
void
curlpp::registry_manager_impl< T >::unrecord
   (
      const T &handle,
      registry_base< T > *registry
   )
{
   typename std::multimap< T, registry_base< T > * >::iterator pos;
   
   pos = m_registry.find(  handle );
   while ( pos != m_registry.end() )
   {
      if ( ( *pos ).second == registry )
      {
         m_registry.erase( pos );
         pos = m_registry.end();
         registry->unrecord( handle );
      }
      else
      {
         pos++;
      } 
   }
}


//\TODO We need to understand why we are obliged to cast handle in order to
//be able to pass it to find. (the paramater is const ) 
template < typename T >
void
curlpp::registry_manager_impl< T >::unrecord
   (
      const T &handle
   )
{
   std::list< registry_base< T > * > handle_list;
   typename std::multimap< T, registry_base< T > * >::iterator pos;
   
   for(
         pos = m_registry.find( handle );
         pos != m_registry.end();
         pos++
      )
   {
      handle_list.push_back( (*pos).second );
   }

   m_registry.erase( handle );

   for(
         typename std::list< registry_base< T > * >::iterator pos = handle_list.begin();
         pos != handle_list.end();
         pos++
      )
   {
      (*pos)->unrecord( handle );
   }
}

template < typename T >
curlpp::registry_manager_impl< T >::~registry_manager_impl()
{
   std::cout << "registry_manager_impl destroyed " << std::endl;
}

