#include "mutex_factory.hpp"
#include "factory_mutex_base.hpp"

utilspp::mutex_factory_container::mutex_factory_container() : m_factory( NULL )
{}

utilspp::mutex_factory_base::~mutex_factory_base()
{}

utilspp::mutex_factory_container::~mutex_factory_container()
{
   delete m_factory;
   m_factory = NULL;
}

utilspp::factory_mutex_base *
utilspp::mutex_factory_container::create_mutex()
{
   utilspp::factory_mutex_base *mutex = NULL;
   
   if( m_factory == NULL )
   {
      throw std::logic_error( "Mutex Factory was not initialized" );
   }
   else
   {
      mutex = m_factory->create_mutex();
   }

   return mutex;
}
