template< typename T, typename T_destroyer >
void
utilspp::set_library_longevity( T *obj, unsigned int longevity, T_destroyer d )
{
   using namespace utilspp::private_members;

   
   lifetime_tracker *p = new concrete_lifetime_tracker< T, T_destroyer >( 
         obj,
         longevity,
         d
         );

   lifetime_library_singleton::instance().add( p );
};

template< typename T >
void 
utilspp::lifetime_library< T >::schedule_destruction( T *obj, void (*func)() )
{
   utilspp::private_members::adapter<T> adapter = { func };
   utilspp::set_library_longevity( obj, get_longevity( obj ), adapter );
}

template< typename T >
void 
utilspp::lifetime_library< T >::on_dead_reference()
{
   throw std::logic_error("Dead reference detected");
}


