#include <cstdlib>
#include "lifetime_with_longevity.hpp"

utilspp::private_members::tracker_array
   utilspp::private_members::m_tracker_array = NULL;

int utilspp::private_members::m_nb_elements = 0;

utilspp::private_members::lifetime_tracker::lifetime_tracker( unsigned int
      longevity ) 
: 
m_longevity( longevity )
{}

utilspp::private_members::lifetime_tracker::~lifetime_tracker()
{}

bool
utilspp::private_members::lifetime_tracker::compare( 
      const lifetime_tracker *l, 
      const lifetime_tracker *r 
      )
{
   return l->m_longevity < r->m_longevity;
}

void
utilspp::private_members::at_exit_func()
{
   assert( 
         ( m_tracker_array != NULL ) && 
         ( m_nb_elements > 0 )
         );

   //Pick the element at the top of the stack.
   lifetime_tracker* top =  
      m_tracker_array[ 
      m_nb_elements - 1
      ];

   //Remove that object off the stack.
   //Don't check errors-realloc with less memory, cause that can't fail.
   m_tracker_array = 
      static_cast< utilspp::private_members::tracker_array >
      (
            std::realloc( 
               m_tracker_array, 
               --m_nb_elements
               )
      );

   //Destroy the element.
   delete top;
}

